- Main Page
- Classes
- Files
- Related Pages

- Class List
- Class Hierarchy
- Class Members

# sc::ProcFileGrp Class Reference

The ProcFileGrp concrete class provides an implementation of FileGrp for a single processor. More...

`#include <fileproc.h>`

Inheritance diagram for sc::ProcFileGrp:

List of all members.

## Public Member Functions
| ProcFileGrp (const Ref< KeyVal > &)
ProcFileGrp * | clone ()
| Clones the given FileGrp. The new FileGrp may need to be initialized additionally.
void | set_localsize (size_t)
| Set the size of locally held data.
void * | localdata ()
void * | obtain_readwrite (distsize_t offset, int size)
| Only one thread can have an unreleased obtain_readwrite at a time.
void * | obtain_readonly (distsize_t offset, int size)
| This gives read access to the file location. No locking is done.
void * | obtain_writeonly (distsize_t offset, int size)
| This gives write access to the data location. No locking is done.
void | release_readonly (void *data, distsize_t offset, int size)
| This is called when read access is no longer needed.
void | release_writeonly (void *data, distsize_t offset, int size)
| This is called when write access is no longer needed.
void | release_readwrite (void *data, distsize_t offset, int size)
| This is called when read/write access is no longer needed.
void | sync ()
| Synchronizes all the nodes.

## Detailed Description

The ProcFileGrp concrete class provides an implementation of FileGrp for a single processor.

## Member Function Documentation

void sc::ProcFileGrp::set_localsize | ( | size_t |  | ) | `[virtual]`

Set the size of locally held data.

When data is accessed using a global offset counting starts at node 0 and proceeds up to node n() - 1.

Implements sc::FileGrp.

void* sc::ProcFileGrp::obtain_readwrite | ( | distsize_t | offset,
|  | int | size |
| ) |  |  | `[virtual]`

Only one thread can have an unreleased obtain_readwrite at a time.

The actual file region locked can be larger than that requested. If the file region is already locked this will block. For this reason, data should be held as read/write for as short a time as possible.

Implements sc::FileGrp.

void sc::ProcFileGrp::release_readwrite | ( | void * | data,
|  | distsize_t | offset,
|  | int | size |
| ) |  |  | `[virtual]`

This is called when read/write access is no longer needed.

The data will be unlocked.

Implements sc::FileGrp.

void sc::ProcFileGrp::sync | ( |  | ) | `[virtual]`

Synchronizes all the nodes.

Consider using this when the way you you access data changes.

Implements sc::FileGrp.

The documentation for this class was generated from the following file:

- fileproc.h